/*
 *	app.h
 *
 *	ATARI VCS/EMU
 *
 *	* Tue Mar 15 20:31:00 JST 2005 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __APP_H__
#define __APP_H__

#include <clip.h>

/****************************************************************************
 *	
 ****************************************************************************/

/* NbNEEFCgύXꍇ́ATURBOV{`ĂB
 * `ĺAturbo()֐ɂ̂܂܈n܂B
 */
#define TURBO -1 /*{{TODO}}*/

/* ؑցE16K\gꍇ́A
 * ELDIRECT_INTERVALɍXV^C~O[~b]`ĂB
 *   XV^C~O̖ڈ́A悻̒ʂłB
 *	11ȉ	Ԃɍ킸nOAbv̊댯B
 *	12	iEׁB48MHz/1WAITȊOł͏Ԃɍ킸nOAbv̊댯B
 *	25	iEׁB48MHz/1WAIT́A̒lK؂łB
 *	33	iEᕉׁB24MHz/2WAIT́A̒lK؂łB
 *	34ȏ	ؑւxāA_łĂ܂܂B
 * EؑցE16K\gȂꍇ́ALDIRECT_INTERVAL`ȂłB
 *   ʏ4K\ƂȂ܂B
 */
#define LDIRECT_INTERVAL 33 /*{{TODO}}*/

/* I[gs[ggpꍇ́A
 * EQUICK_REPEAT_PADS`ĂB
 * EQUICK_REPEAT_PADSɍI[gs[gLɂPAD_*̑gݍ킹w肵ĂB
 * EQUICK_REPEAT_DELAYɍI[gs[gJn܂ł̎Ԃw肵ĂB
 * I[gs[ggpȂꍇ́A
 * EQUICK_REPEAT_PADS`ȂłB
 * EQUICK_REPEAT_PADS/DELAY̒`̗LɊւ炸AI[gs[g͍s܂B
 */
#define QUICK_REPEAT /*{{TODO}}*/
#define QUICK_REPEAT_PADS	(PAD_LF | PAD_UP | PAD_RI | PAD_DN)
//#define QUICK_REPEAT_DELAY	SEC(0.25)
#define QUICK_REPEAT_DELAY	SEC(0.50)

/* |[Y@\gꍇ́AUSE_PAUSEV{`ĂB
 * ܂AAvP[V̒ʏwiFɂ킹āAPAUSE_COLORIĂB
 */
//#define USE_PAUSE /*{{TODO}}*/
#ifdef USE_PAUSE
#define PAUSE_FONT	0x80		/* PAUSEtHg         */
#ifndef LDIRECT_INTERVAL
//#define PAUSE_COLOR	0x130		/* PAUSEJ[(wip) */
#define PAUSE_COLOR	0x203		/* PAUSEJ[(wip) */
#else /*LDIRECT_INTERVAL*/
//#define PAUSE_COLOR	0x5f0		/* PAUSEJ[(16KEwip) */
#define PAUSE_COLOR	0xa0f		/* PAUSEJ[(16KEwip) */
#endif /*LDIRECT_INTERVAL*/
#define PAUSE_STR	"PAUSE"		/* PAUSEbZ[W       */
#define PAUSE_W		(5 * 5 + 2)	/* PAUSEbZ[W̉ */
#define PAUSE_H		(10    + 2)	/* PAUSEbZ[W̏c */
#define PAUSE_X		((DISP_X - PAUSE_W) / 2) /* \ʒu */
#define PAUSE_Y		((DISP_Y - PAUSE_H) / 2) /* \ʒu */
#endif /*USE_PAUSE*/

/****************************************************************************
 *	
 ****************************************************************************/

#define FPS	60			/* t[[g */
#define SEC(s)	((int)(FPS * (s)))	/* b->t[ϊ */

typedef struct _FILEITEM {
	char fname[MAXFILENAME + 1];
	int size;
} FILEITEM;

#define MAX_FILE	50
#define MAX_DISP	13

/* main.c */
void app_init();
void app_exit();
void schedule();
void app_main();

/* fram.c */
extern int CYCLE; /* RAMɔzu */
extern int NOW;   /* RAMɔzu */
int/*%data*/ w65c02_read(/*%addr*/);
void w65c02_write(/*%addr,%data*/);

/* emu.c */
int vcs_run(const char* fname, int sound_on);

/****************************************************************************
 *	
 ****************************************************************************/

#include "work.h"

#endif /*__APP_H__*/
