/*	
 *	framdraw.c
 *
 *	16K`
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2005 Naoyuki Sawa
 *
 *	* Tue Jun 4 21:28:00 JST 2005 Naoyuki Sawa
 *	- 4bit`惋[`(PDW_Draw_4BN)Aframldir.cframdraw.cֈړ܂B
 *	  4bit`惋[`gȂ16~\AvP[V(G~[^Ȃ)ŁA
 *	  4bit`惋[`RAM̂邽߂łB
 *	- 4bit`惋[`gȂ16~\AvP[V́A
 *	  framldir.oRAMɔzuAframdraw.cSRAMɔzuĂB
 */
#include "clip.h"

/****************************************************************************
 *	pceLCDDrawObject() 4bit`T|[g
 ****************************************************************************/

/* clipldir.cnew_pceLCDDrawObject()Ăяo܂B
 * * NbsÓAĂяoOnew_pceLCDDrawObject()ɂĊĂ܂B
 * * DRAW_OBJECT.dest́Anew_LCDDrawObject()ɂĊmɗLlɐݒ肳Ă܂B
 *   PDW_Draw_4BN()ł́ADRAW_OBJECT.dest̋Kl擾鏈sKv͂܂B
 */
void
PDW_Draw_4BN(DRAW_OBJECT obj)
{
	int n, x, y, step, dest_stride, src_stride;
	unsigned char *dest_buf, *src_mask, mask;
	unsigned int *src_buf, pixel;

	/* ]_A]摜̐8sNZPʂ̂sNZڂJn邩H */
	step = obj.sx & 7;

	/* ]sNZAhX߂܂B */
	n = (obj.src->header.w * obj.sy + obj.sx) / 8;
	src_buf = (unsigned int*)obj.src->buf + n;
	src_mask = obj.src->mask + n;
	src_stride = obj.src->header.w / 8 - (step + obj.dw - 1) / 8;
	/*                                                  ~~~         */
	/* 8Xebvɐiނ̂ł͂ȂA9Xebvڂ̐擪Őiނ */

	/* c]CpӂĂ܂B */
	y = obj.dh;

	/* ]ɂāA𕪂܂B(DRW_NOMAL=0Ɖ)
	 * ]ȊÕtOw肳ĂA{ɔC܂B
	 */
	switch(obj.param) {
	case 0/*]Ȃ*/:
		/* ]sNZAhX߂܂B */
		dest_buf = obj.dest->buf + obj.dest->w * obj.dy + obj.dx;
		dest_stride = obj.dest->w - obj.dw;

		if(obj.src->header.mask) {
			do {
				/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
				 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
				 */
				pixel = *src_buf;	/* sNZт MSB:67452301:LSB ̏ł */
				mask = *src_mask;	/* sNZт MSB:01234567:LSB ̏ł */

				/* c萅sNZ擾܂B */
				x = obj.dw;

				/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
				switch(step) {
LOOP_00: /* ͔͂щz܂ */
					/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
					pixel = *++src_buf;
					mask = *++src_mask;
#define PIXEL(p, m) \
					/* ssNZȂA`܂B */ \
					if(mask & (1 << (m))) *dest_buf = pixel >> (p) * 4 & 15; \
					dest_buf++; \
					/* 1C]A܂B */ \
					if(--x == 0) break;
				case 0:       PIXEL(1, 7);
				case 1:       PIXEL(0, 6);
				case 2:       PIXEL(3, 5);
				case 3:       PIXEL(2, 4);
				case 4:       PIXEL(5, 3);
				case 5:       PIXEL(4, 2);
				case 6:       PIXEL(7, 1);
				default/*7*/: PIXEL(6, 0); goto LOOP_00;
#undef PIXEL
				}

				/* ]E]sNZAhX̃C֐i߂܂B */
				dest_buf += dest_stride;
				src_buf += src_stride;
				src_mask += src_stride;
			} while(--y != 0);
		} else {
			do {
				/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
				 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
				 */
				pixel = *src_buf;	/* sNZт MSB:67452301:LSB ̏ł */

				/* c萅sNZ擾܂B */
				x = obj.dw;

				/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
				switch(step) {
LOOP_01: /* ͔͂щz܂ */
					/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
					pixel = *++src_buf;
#define PIXEL(p) \
					/* sNZA`܂B */ \
					*dest_buf++ = pixel >> (p) * 4 & 15; \
					/* 1C]A܂B */ \
					if(--x == 0) break;
				case 0:       PIXEL(1);
				case 1:       PIXEL(0);
				case 2:       PIXEL(3);
				case 3:       PIXEL(2);
				case 4:       PIXEL(5);
				case 5:       PIXEL(4);
				case 6:       PIXEL(7);
				default/*7*/: PIXEL(6); goto LOOP_01;
#undef PIXEL
				}

				/* ]E]sNZAhX̃C֐i߂܂B */
				dest_buf += dest_stride;
				src_buf += src_stride;
			} while(--y != 0);
		}
		break;

	case DRW_REVX:
		/* ]sNZAhX߂܂B */
		dest_buf = obj.dest->buf + obj.dest->w * obj.dy + obj.dx + obj.dw - 1;
		dest_stride = obj.dest->w + obj.dw;

		if(obj.src->header.mask) {
			do {
				/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
				 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
				 */
				pixel = *src_buf;	/* sNZт MSB:67452301:LSB ̏ł */
				mask = *src_mask;	/* sNZт MSB:01234567:LSB ̏ł */

				/* c萅sNZ擾܂B */
				x = obj.dw;

				/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
				switch(step) {
LOOP_10: /* ͔͂щz܂ */
					/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
					pixel = *++src_buf;
					mask = *++src_mask;
#define PIXEL(p, m) \
					/* ssNZȂA`܂B */ \
					if(mask & (1 << (m))) *dest_buf = pixel >> (p) * 4 & 15; \
					dest_buf--; \
					/* 1C]A܂B */ \
					if(--x == 0) break;
				case 0:       PIXEL(1, 7);
				case 1:       PIXEL(0, 6);
				case 2:       PIXEL(3, 5);
				case 3:       PIXEL(2, 4);
				case 4:       PIXEL(5, 3);
				case 5:       PIXEL(4, 2);
				case 6:       PIXEL(7, 1);
				default/*7*/: PIXEL(6, 0); goto LOOP_10;
#undef PIXEL
				}

				/* ]E]sNZAhX̃C֐i߂܂B */
				dest_buf += dest_stride;
				src_buf += src_stride;
				src_mask += src_stride;
			} while(--y != 0);
		} else {
			do {
				/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
				 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
				 */
				pixel = *src_buf;	/* sNZт MSB:67452301:LSB ̏ł */

				/* c萅sNZ擾܂B */
				x = obj.dw;

				/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
				switch(step) {
LOOP_11: /* ͔͂щz܂ */
					/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
					pixel = *++src_buf;
#define PIXEL(p) \
					/* sNZA`܂B */ \
					*dest_buf-- = pixel >> (p) * 4 & 15; \
					/* 1C]A܂B */ \
					if(--x == 0) break;
				case 0:       PIXEL(1);
				case 1:       PIXEL(0);
				case 2:       PIXEL(3);
				case 3:       PIXEL(2);
				case 4:       PIXEL(5);
				case 5:       PIXEL(4);
				case 6:       PIXEL(7);
				default/*7*/: PIXEL(6); goto LOOP_11;
#undef PIXEL
				}

				/* ]E]sNZAhX̃C֐i߂܂B */
				dest_buf += dest_stride;
				src_buf += src_stride;
			} while(--y != 0);
		}
		break;

	case DRW_REVY:
		/* ]sNZAhX߂܂B */
		dest_buf = obj.dest->buf + obj.dest->w * (obj.dy + obj.dh - 1) + obj.dx;
		dest_stride = -obj.dest->w - obj.dw;

		if(obj.src->header.mask) {
			do {
				/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
				 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
				 */
				pixel = *src_buf;	/* sNZт MSB:67452301:LSB ̏ł */
				mask = *src_mask;	/* sNZт MSB:01234567:LSB ̏ł */

				/* c萅sNZ擾܂B */
				x = obj.dw;

				/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
				switch(step) {
LOOP_20: /* ͔͂щz܂ */
					/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
					pixel = *++src_buf;
					mask = *++src_mask;
#define PIXEL(p, m) \
					/* ssNZȂA`܂B */ \
					if(mask & (1 << (m))) *dest_buf = pixel >> (p) * 4 & 15; \
					dest_buf++; \
					/* 1C]A܂B */ \
					if(--x == 0) break;
				case 0:       PIXEL(1, 7);
				case 1:       PIXEL(0, 6);
				case 2:       PIXEL(3, 5);
				case 3:       PIXEL(2, 4);
				case 4:       PIXEL(5, 3);
				case 5:       PIXEL(4, 2);
				case 6:       PIXEL(7, 1);
				default/*7*/: PIXEL(6, 0); goto LOOP_20;
#undef PIXEL
				}

				/* ]E]sNZAhX̃C֐i߂܂B */
				dest_buf += dest_stride;
				src_buf += src_stride;
				src_mask += src_stride;
			} while(--y != 0);
		} else {
			do {
				/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
				 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
				 */
				pixel = *src_buf;	/* sNZт MSB:67452301:LSB ̏ł */

				/* c萅sNZ擾܂B */
				x = obj.dw;

				/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
				switch(step) {
LOOP_21: /* ͔͂щz܂ */
					/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
					pixel = *++src_buf;
#define PIXEL(p) \
					/* sNZA`܂B */ \
					*dest_buf++ = pixel >> (p) * 4 & 15; \
					/* 1C]A܂B */ \
					if(--x == 0) break;
				case 0:       PIXEL(1);
				case 1:       PIXEL(0);
				case 2:       PIXEL(3);
				case 3:       PIXEL(2);
				case 4:       PIXEL(5);
				case 5:       PIXEL(4);
				case 6:       PIXEL(7);
				default/*7*/: PIXEL(6); goto LOOP_21;
#undef PIXEL
				}

				/* ]E]sNZAhX̃C֐i߂܂B */
				dest_buf += dest_stride;
				src_buf += src_stride;
			} while(--y != 0);
		}
		break;

	case DRW_REVX | DRW_REVY:
		/* ]sNZAhX߂܂B */
		dest_buf = obj.dest->buf + obj.dest->w * (obj.dy + obj.dh - 1) + obj.dx + obj.dw - 1;
		dest_stride = -obj.dest->w + obj.dw;

		if(obj.src->header.mask) {
			do {
				/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
				 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
				 */
				pixel = *src_buf;	/* sNZт MSB:67452301:LSB ̏ł */
				mask = *src_mask;	/* sNZт MSB:01234567:LSB ̏ł */

				/* c萅sNZ擾܂B */
				x = obj.dw;

				/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
				switch(step) {
LOOP_30: /* ͔͂щz܂ */
					/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
					pixel = *++src_buf;
					mask = *++src_mask;
#define PIXEL(p, m) \
					/* ssNZȂA`܂B */ \
					if(mask & (1 << (m))) *dest_buf = pixel >> (p) * 4 & 15; \
					dest_buf--; \
					/* 1C]A܂B */ \
					if(--x == 0) break;
				case 0:       PIXEL(1, 7);
				case 1:       PIXEL(0, 6);
				case 2:       PIXEL(3, 5);
				case 3:       PIXEL(2, 4);
				case 4:       PIXEL(5, 3);
				case 5:       PIXEL(4, 2);
				case 6:       PIXEL(7, 1);
				default/*7*/: PIXEL(6, 0); goto LOOP_30;
#undef PIXEL
				}

				/* ]E]sNZAhX̃C֐i߂܂B */
				dest_buf += dest_stride;
				src_buf += src_stride;
				src_mask += src_stride;
			} while(--y != 0);
		} else {
			do {
				/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
				 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
				 */
				pixel = *src_buf;	/* sNZт MSB:67452301:LSB ̏ł */

				/* c萅sNZ擾܂B */
				x = obj.dw;

				/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
				switch(step) {
LOOP_31: /* ͔͂щz܂ */
					/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
					pixel = *++src_buf;
#define PIXEL(p) \
					/* sNZA`܂B */ \
					*dest_buf-- = pixel >> (p) * 4 & 15; \
					/* 1C]A܂B */ \
					if(--x == 0) break;
				case 0:       PIXEL(1);
				case 1:       PIXEL(0);
				case 2:       PIXEL(3);
				case 3:       PIXEL(2);
				case 4:       PIXEL(5);
				case 5:       PIXEL(4);
				case 6:       PIXEL(7);
				default/*7*/: PIXEL(6); goto LOOP_31;
#undef PIXEL
				}

				/* ]E]sNZAhX̃C֐i߂܂B */
				dest_buf += dest_stride;
				src_buf += src_stride;
			} while(--y != 0);
		}
		break;
	}
}

